﻿using ProjectRepairWork.Reports;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Unity;

namespace ProjectRepairWork.Forms
{
    public partial class FormDirectoryReport : Form
    {
        private readonly IUnityContainer _container;
        public FormDirectoryReport(IUnityContainer container)
        {
            _container = container ?? throw new ArgumentNullException(nameof(container));
            InitializeComponent();
        }

        private void ButtonFormulate_Click(object sender, EventArgs e)
        {
            try
            {
                if (!checkBoxContractors.Checked && !checkBoxPremises.Checked && !checkBoxWorks.Checked)
                {
                    throw new Exception("Не выбран ни один справочник для выгрузки");
                }

                var sfd = new SaveFileDialog()
                {
                    Filter = "Docx Files | *.docx"
                };

                if (sfd.ShowDialog() != DialogResult.OK)
                {
                    throw new Exception("Не выбран айл для отчета");
                }

                if (_container.Resolve<DocReport>().CreateDoc(sfd.FileName, checkBoxContractors.Checked,
                    checkBoxPremises.Checked, checkBoxWorks.Checked))
                {
                    MessageBox.Show("Документ сформирован", "Формирование документа",
                        MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Возникли ошибки при формировании документа. Подробности в логах",
                        "Формирование документа",
                        MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            catch(Exception ex)

            {
                MessageBox.Show(ex.Message, "Ошибки при создании отчета", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }
    }
}
